<template>
  <a-spin :spinning="confirmLoading">
    <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
      <a-row>
      <!--
        <a-col :span="24">
          <a-form-item label="事件ID" v-bind="validateInfos.eventId">
	          <a-input-number v-model:value="formData.eventId" placeholder="请输入事件ID" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        
        <a-col :span="24">
          <a-form-item label="事件类型" v-bind="validateInfos.eventTp">
	          <a-input-number v-model:value="formData.eventTp" placeholder="请输入事件类型" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="处理方法" v-bind="validateInfos.content">
            <a-input v-model:value="formData.content" placeholder="请输入处理方法" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        -->
        <a-col :span="24">
          <a-form-item label="步骤描述" v-bind="validateInfos.handleDes">
            <a-input v-model:value="formData.handleDes" placeholder="请输入步骤描述" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="执行机构" v-bind="validateInfos.exeOrg">
            <a-input v-model:value="formData.exeOrg" placeholder="请输入执行机构" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="执行部门" v-bind="validateInfos.exeDepart">
            <a-input v-model:value="formData.exeDepart" placeholder="请输入执行部门" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="执行角色" v-bind="validateInfos.exeRole">
            <a-input v-model:value="formData.exeRole" placeholder="请输入执行角色" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="联系方式" v-bind="validateInfos.tel">
            <a-input v-model:value="formData.tel" placeholder="请输入联系方式" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
        <a-col :span="24">
          <a-form-item label="所属策略" v-bind="validateInfos.des">
            <a-input v-model:value="formData.des" placeholder="请输入所属策略" :disabled="disabled"></a-input>
          </a-form-item>
        </a-col>
         <a-col :span="24">
          <a-form-item label="处理顺序" v-bind="validateInfos.step">
	          <a-input-number v-model:value="formData.step" placeholder="请输入处理顺序" style="width: 100%" :disabled="disabled"/>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/@/utils/http/axios';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { getValueType } from '/@/utils';
  import { saveOrUpdate } from '../BcsHandleMethod.api';
  import { Form } from 'ant-design-vue';
  
  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: ()=>{} },
    formBpm: { type: Boolean, default: true }
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    eventId: undefined,
    eventTp: undefined,
    content: '',   
    handleDes: '',   
    step: undefined,
    exeOrg: '',   
    exeDepart: '',   
    exeRole: '',   
    tel: '',   
    des: '',   
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = {
  };
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: true });

  // 表单禁用
  const disabled = computed(()=>{
    if(props.formBpm === true){
      if(props.formData.disabled === false){
        return false;
      }else{
        return true;
      }
    }
    return props.formDisabled;
  });

  
  /**
   * 新增
   */
  function add(eventId) {
    formData.eventId=eventId;
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      //赋值
      Object.assign(formData, record);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }


  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    min-height: 500px !important;
    overflow-y: auto;
    padding: 24px 24px 24px 24px;
  }
</style>
